#include <iostream>
#include <vector>
#include <queue>
#include<algorithm>
#include<map>
using namespace std;
int main()
{
    int n,k;
    cin>>n>>k;
    vector<int>d(k);
    for(int i=0;i<k;i++)
    {
        cin>>d[i];
    }
    vector<pair<int,int>> del;
    int npom=n;
    /*for(int i=2;i*i<=n;i++)
    {
        int cnt=0;
        while(npom%i==0&& npom>1)
        {
            npom=npom/i;
            cnt++;
        }
        pair<int,int>po;
        po.first=i;
        po.second=cnt;
        if(po.second>0)
        del.push_back(po);
    }
    */
    map<int,int> m;
    m[1]=1;
    for(int i=0;i<del.size();i++)
    {
        int x=del[i].first;
        for(int j=0;j<del[i].second;j++)
        {
            m[x]=m[x/del[i].first]^x;
            x=x*del[i].first;

        }
    }
    for(int i=0;i<d.size();i++)
    {
        int pom=1;
        int r=d[i];
        for(int j=2;j*j<=r;j++)
        {
            if(r%j==0)
            {pom=pom^j;
            if(j!=r/j)
            pom=pom^(r/j);
            }
        }
        if(d[i]!=1)
            pom=pom^d[i];
        m[d[i]]=pom;
    }
    for(int i=0;i<d.size();i++)
    {
        cout<<m[d[i]]<<" ";
    }
}